import java.util.*;

class MyCharacter {
	public char c;

	public MyCharacter(char c) {
		this.c = c;
	}

	public MyCharacter clone() {
		MyCharacter ret = new MyCharacter(c);
		return ret;
	}

	public String toString() {
		return Character.toString(c);
	}
}

public class Walkthrough {
	public static void main(String args[]) {
		LinkedList<MyCharacter> l1 = new LinkedList<MyCharacter>();
		LinkedList<MyCharacter> l2 = new LinkedList<MyCharacter>();
		LinkedList<MyCharacter> l3 = new LinkedList<MyCharacter>();
		MyCharacter mc = new MyCharacter('a');
		String s = new String();
		for (char c = 'a'; c <= 'd'; c++) {
			mc.c = c;
			l1.add(mc);
			l2.add(mc.clone());
			l3.add(mc.clone());
			s = s + c;
		}
		System.out.println("1: " + l1.get(0).c + " " + l2.get(0).c + " "
				+ s.charAt(0));
		for (char i = 3; i > 0; i--) {
			MyCharacter v = l2.get(i);
			l3.set(i, v);
		}
		for (char i = 0; i <= 3; i++) {
			l1.get(i).c = l3.get(i).c;
		}
		System.out.println("2: " + l1.toString() + " " + l3.toString());
		for (int i = 0; i <= 3; i = i + 2) { // A t t e n t i o n : We i
												// ncrement by 2
			l1.set(i, new MyCharacter(s.charAt(i)));
			l2.get(i).c = 'a';
		}
		System.out.println("3: " + l1.toString() + " " + l3.toString());
	}
}